> For the complete documentation index, see [llms.txt](https://docs.realmjoin.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.realmjoin.com/automation/runbooks/runbook-references/device/security/restrict-or-release-code-execution.md).

# Restrict Or Release Code Execution

### Description

This runbook restricts code execution on a device via Microsoft Defender for Endpoint so that only Microsoft-signed code can run. Optionally, it can remove an existing restriction. Provide a short reason so the action is documented in the service.

### Location

Device → Security → Restrict Or Release Code Execution

**Full Runbook name**

rjgit-device\_security\_restrict-or-release-code-execution

### Details

| Property         | Value                              |
| ---------------- | ---------------------------------- |
| Version          | 1.0.1                              |
| Required modules | RealmJoin.RunbookHelper (>= 0.8.9) |
| Schedulable      | no                                 |

### Permissions

#### Application permissions

* **Type**: WindowsDefenderATP
  * Machine.Read.All
    * *Finds the Defender for Endpoint machine via /machines filtered by aadDeviceId*
  * Machine.RestrictExecution
    * *Triggers restrictCodeExecution or unrestrictCodeExecution on the machine*

### Parameters

#### DeviceId

The device ID of the target device.

| Property         | Value                                  |
| ---------------- | -------------------------------------- |
| Required         | true                                   |
| Default Value    |                                        |
| Type             | String                                 |
| Hidden in portal | yes (preset via runbook customization) |

#### Release

"Restrict Code Execution" (final value: false) or "Remove Code Restriction" (final value: true) can be selected as action to perform. If set to false, the runbook will restrict code execution on the device in Defender for Endpoint. If set to true, it will remove an existing code execution restriction on the device in Defender for Endpoint.

| Property            | Value   |
| ------------------- | ------- |
| Required            | true    |
| Default Value       | False   |
| Type                | Boolean |
| Portal display name | Action  |

**Portal options**

| Portal option           | Value |
| ----------------------- | ----- |
| Restrict Code Execution | false |
| Remove Code Restriction | true  |

#### Comment

A short reason for the (un)restriction action.

| Property            | Value                      |
| ------------------- | -------------------------- |
| Required            | true                       |
| Default Value       | Possible security risk.    |
| Type                | String                     |
| Portal display name | Reason for (Un)Restriction |

[Back to Runbook Reference overview](/automation/runbooks/runbook-references.md)


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.realmjoin.com/automation/runbooks/runbook-references/device/security/restrict-or-release-code-execution.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
